## START: Set by rpmautospec
## (rpmautospec version 0.7.3)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 3;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

%bcond check 1
# We can run these in a local mock build with --enable-network.
%bcond network_tests 0

Name:           pre-commit
Version:        4.2.0
Release:        %autorelease
Summary:        Framework for managing and maintaining multi-language pre-commit hooks

# SPDX
License:        MIT
URL:            https://pre-commit.com
%global forgeurl https://github.com/pre-commit/pre-commit
Source0:        %{forgeurl}/archive/v%{version}/pre-commit-%{version}.tar.gz

# Man pages hand-written for Fedora in groff_man(7) format based on --help:
Source100:       pre-commit.1
Source101:       pre-commit-autoupdate.1
Source102:       pre-commit-clean.1
Source103:       pre-commit-gc.1
Source104:       pre-commit-help.1
Source105:       pre-commit-init-templatedir.1
Source106:       pre-commit-install.1
Source107:       pre-commit-install-hooks.1
Source108:       pre-commit-migrate-config.1
Source109:       pre-commit-run.1
Source110:       pre-commit-sample-config.1
Source111:       pre-commit-try-repo.1
Source112:       pre-commit-uninstall.1
Source113:       pre-commit-validate-config.1
Source114:       pre-commit-validate-manifest.1

BuildSystem:            pyproject
BuildOption(prep):      -S git
%if %{with check}
BuildOption(generate_buildrequires): requirements-dev-filtered.txt
%endif
BuildOption(install):   -l pre_commit
# Any Python files inside pre_commit.resources are templates and are not
# intended to be imported.
BuildOption(check):     -e 'pre_commit.resources.*'

BuildArch:      noarch

# Much functionality relies on invoking git commands.
Requires:       git-core
BuildRequires:  git-core

%if %{with check}
# Manually added to speed up the %%check section
BuildRequires:  python3dist(pytest-xdist)
%endif

%description
A framework for managing and maintaining multi-language pre-commit hooks.


%prep -a
# Do not generate BR’s for coverage, linters, etc.:
sed -r '/^(covdefaults|coverage)\b/d' requirements-dev.txt |
  tee requirements-dev-filtered.txt


%install -a
install -t %{buildroot}%{_mandir}/man1 -p -m 0644 -D \
    %{SOURCE100} %{SOURCE101} %{SOURCE102} %{SOURCE103} %{SOURCE104} \
    %{SOURCE105} %{SOURCE106} %{SOURCE107} %{SOURCE108} %{SOURCE109} \
    %{SOURCE110} %{SOURCE111} %{SOURCE112} %{SOURCE113} %{SOURCE114}


%check -a
%if %{with check}
# For general discusson on test failures building distribution packages, see:
# https://github.com/pre-commit/pre-commit/issues/1183,
# https://github.com/pre-commit/pre-commit/issues/1202

# Does not work under (i.e., respect) an “external” PYTHONPATH
k="${k-}${k+ and }not test_installed_from_venv"

%if %{without network_tests}
k="${k-}${k+ and }not test_additional_dependencies_roll_forward"
k="${k-}${k+ and }not test_repository_state_compatibility[v1]"
k="${k-}${k+ and }not test_repository_state_compatibility[v2]"
k="${k-}${k+ and }not test_reinstall"
k="${k-}${k+ and }not test_control_c_control_c_on_install"
k="${k-}${k+ and }not test_invalidated_virtualenv"
k="${k-}${k+ and }not test_really_long_file_paths"
k="${k-}${k+ and }not test_local_python_repo"
%endif

# These are the tests that run by default via tox; see tox.ini. See also
# .github/workflows/main.yml.
%pytest --ignore=tests/languages -k "${k-}" -v
%endif


%files -f %{pyproject_files}
%doc README.md CHANGELOG.md CONTRIBUTING.md
%{_bindir}/pre-commit
%{_mandir}/man1/pre-commit*.1*


%changelog
## START: Generated by rpmautospec
* Fri May 09 2025 Benjamin A. Beasley <code@musicinmybrain.net> - 4.2.0-3
- Fix check bcond (empty BuildOption is not permitted)

* Wed Apr 30 2025 Benjamin A. Beasley <code@musicinmybrain.net> - 4.2.0-2
- F41+: Use the provisional pyproject declarative buildsystem

* Wed Mar 19 2025 Benjamin A. Beasley <code@musicinmybrain.net> - 4.2.0-1
- Update to 4.2.0 (close RHBZ#2353271)

* Tue Feb 25 2025 Benjamin A. Beasley <code@musicinmybrain.net> - 4.1.0-6
- Add a runtime dependency on git-core

* Tue Feb 25 2025 Benjamin A. Beasley <code@musicinmybrain.net> - 4.1.0-5
- Add a set of man pages

* Mon Feb 24 2025 Benjamin A. Beasley <code@musicinmybrain.net> - 4.1.0-3
- Simplify testing
- Always run an import-only “smoke test”
- Do not run language-specific tests; run only the tests that tox would run

* Tue Jan 21 2025 Benjamin A. Beasley <code@musicinmybrain.net> - 4.1.0-1
- Update to 4.1.0 (close RHBZ#2339032)

* Sat Jan 18 2025 Fedora Release Engineering <releng@fedoraproject.org> - 4.0.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_42_Mass_Rebuild

* Tue Oct 08 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 4.0.1-1
- Update to 4.0.1 (close RHBZ#2317289)

* Mon Oct 07 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 4.0.0-1
- Update to 4.0.0 (close RHBZ#2316717)

* Mon Jul 29 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 3.8.0-1
- Update to 3.8.0 (close RHBZ#2300465)

* Fri Jul 19 2024 Fedora Release Engineering <releng@fedoraproject.org> - 3.7.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_41_Mass_Rebuild

* Fri Jun 07 2024 Python Maint <python-maint@redhat.com> - 3.7.0-2
- Rebuilt for Python 3.13

* Tue Mar 26 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 3.7.0-1
- Update to 3.7.0 (close RHBZ#2271311)

* Sun Feb 18 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 3.6.2-1
- Update to 3.6.2 (close RHBZ#2264761)

* Mon Feb 12 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 3.6.1-1
- Update to 3.6.1 (close RHBZ#2263682)

* Fri Jan 26 2024 Fedora Release Engineering <releng@fedoraproject.org> - 3.6.0-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Sun Jan 21 2024 Fedora Release Engineering <releng@fedoraproject.org> - 3.6.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Mon Jan 01 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 3.6.0-2
- Assert that the .dist-info directory contains a license file
- Simplify setting up the git repository required by the tests

* Tue Dec 19 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 3.6.0-1
- Update to 3.6.0 (close RHBZ#2253802)

* Fri Nov 03 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 3.5.0-2
- Patch for Python 3.13 (close RHBZ#2247263)

* Tue Oct 24 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 3.5.0-1
- Update to 3.5.0 (close RHBZ#2243884)

* Sun Sep 03 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 3.4.0-1
- Update to 3.4.0 (close RHBZ#2237001)

* Mon Jul 24 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 3.3.3-1
- Update to 3.3.3 (close RHBZ#2192407)

* Fri Jul 21 2023 Fedora Release Engineering <releng@fedoraproject.org> - 3.2.2-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Thu Jun 29 2023 Python Maint <python-maint@redhat.com> - 3.2.2-2
- Rebuilt for Python 3.12

* Tue Apr 04 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 3.2.2-1
- Update to 3.2.2 (close RHBZ#2173816)

* Thu Feb 23 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 3.1.0-1
- Update to 3.1.0 (close RHBZ#2172751)

* Fri Feb 03 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 3.0.4-1
- Update to 3.0.4 (close RHBZ#2163591)

* Mon Jan 23 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 2.21.0-2
- Use ruby, not rubypick

* Fri Jan 20 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 2.21.0-1
- Update to 2.21.0 (close RHBZ#2156253); fixes FTBFS with git ≥ 2.38.1

* Fri Jan 20 2023 Fedora Release Engineering <releng@fedoraproject.org> - 2.20.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_38_Mass_Rebuild

* Fri Jul 22 2022 Fedora Release Engineering <releng@fedoraproject.org> - 2.20.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Tue Jul 12 2022 Benjamin A. Beasley <code@musicinmybrain.net> - 2.20.0-1
- Update to 2.20.0 (close RHBZ#2105849)

* Mon Jun 13 2022 Python Maint <python-maint@redhat.com> - 2.19.0-2
- Rebuilt for Python 3.11

* Sun May 15 2022 Benjamin A. Beasley <code@musicinmybrain.net> - 2.19.0-1
- Update to 2.19.0

* Thu Mar 24 2022 Benjamin A. Beasley <code@musicinmybrain.net> - 2.16.0-3
- Use pytest-env, now that it is packaged
- Skip tests more precisely/selectively
- Drop unnecessary BR on deprecated python-mock
- Port to pyproject-rpm-macros

* Fri Jan 21 2022 Fedora Release Engineering <releng@fedoraproject.org> - 2.16.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Mon Dec 06 2021 Chedi Toueiti <chedi.toueiti@gmail.com> - 2.16.0-1
- Update to version 2.16.0 (#2027887)

* Fri Oct 01 2021 Chedi Toueiti <chedi.toueiti@gmail.com> - 2.14.1-1
- Update to version 2.15.0 (#2000799)

* Wed Sep 01 2021 Chedi Toueiti <chedi.toueiti@gmail.com> - 2.14.1-1
- Upate to version 2.14.1 (#1990997)

* Tue Jul 27 2021 Fedora Release Engineering <releng@fedoraproject.org> - 2.13.0-2
- Second attempt - Rebuilt for
  https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Sat Jul 03 2021 Aniket Pradhan <major AT fedoraproject DOT org> - 2.13.0-1
- Version update to 2.13.0
- Remove redundant dependency generator call
- Use pytest macro
- Remove unnecessary python-devel version requirement
- Removed the dependency for Fedora 31 or lower

* Fri Jun 04 2021 Python Maint <python-maint@redhat.com> - 2.11.1-2
- Rebuilt for Python 3.10

* Sun Mar 21 2021 Chedi Toueiti <chedi.toueiti@gmail.com> - 2.11.1-1
- Update to version 2.11.1

* Wed Jan 27 2021 Fedora Release Engineering <releng@fedoraproject.org> - 2.5.1-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild

* Tue Jul 28 2020 Fedora Release Engineering <releng@fedoraproject.org> - 2.5.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Mon Jun 22 2020 Lumír Balhar <lbalhar@redhat.com> - 2.5.1-1
- Update to 2.5.1

* Tue May 26 2020 Miro Hrončok <mhroncok@redhat.com> - 2.4.0-2
- Rebuilt for Python 3.9

* Wed May 13 2020 Artem Polishchuk <ego.cordatus@gmail.com> - 2.4.0-1
- Update to 2.4.0

* Thu Apr 23 2020 Artem Polishchuk <ego.cordatus@gmail.com> - 2.3.0-1
- Update to 2.3.0

* Thu Mar 12 2020 Artem Polishchuk <ego.cordatus@gmail.com> - 2.2.0-1
- Update to 2.2.0

* Mon Feb 24 2020 Artem Polishchuk <ego.cordatus@gmail.com> - 2.1.1-1
- Update to 2.1.1

* Mon Feb 24 2020 Artem Polishchuk <ego.cordatus@gmail.com> - 2.1.0-1
- Update to 2.1.0

* Mon Jan 20 2020 Artem Polishchuk <ego.cordatus@gmail.com> - 1.21.0-1
- Update to 1.21.0
- Thanks Aniket Pradhan <major AT fedoraproject DOT org> for help with packaging
- Thanks Miro Hrončok <mhroncok@redhat.com> for help with packaging

* Sun Dec 08 2019 Artem Polishchuk <ego.cordatus@gmail.com> - 1.20.0-1
- Update to 1.20.0

* Thu Oct 24 2019 Artem Polishchuk <ego.cordatus@gmail.com> - 1.18.3-8
- Update to 1.18.3

* Sat Mar 30 2019 Artem Polishchuk <ego.cordatus@gmail.com> - 1.14.4-1
- Initial package

## END: Generated by rpmautospec
